clear all
close all
a = -5;
b = 7;
counter = 0;
Nrange = 2.^[2:11];
for N = Nrange
  counter = counter+1;
  y = linspace(0,1,N+1)';
  y = y(1:N);
  x = (b-a)*y+a;
  f = rand(N,1)+sqrt(-1)*rand(N,1);
  F = exp(-sqrt(-1)*[0:N-1].'*2*pi*y.');
  IF = F';
  tmvtot(counter) = 0;
  for j = 1:100
    tmv = cputime;  
    fhatmv = F*(f.*exp(i*N*pi*y));
    fhatmv = fhatmv*sqrt(b-a)/N;
    fhathatmv = (IF*fhatmv).*exp(-i*N*pi*y)/N;
    fhathatmv = fhathatmv*N/sqrt(b-a);
    tmvtot(counter) = tmvtot(counter)+cputime-tmv;
  end
  tffttot(counter) = 0;
  for j = 1:100
    tfft = cputime;
    fhatfft = fft(f.*exp(i*N*pi*y));
    fhatfft = fhatfft*sqrt(b-a)/N;
    fhathatfft = ifft(fhatfft).*exp(-i*N*pi*y);
    fhathatfft = fhathatfft*N/sqrt(b-a);
    tffttot(counter) = tffttot(counter)+cputime-tfft;
  end    
  tfftshifttot(counter) = 0;
  for j = 1:100
    tfftshift = cputime;
    fhatfftshift = fftshift(fft(f));
    fhatfftshift = fhatfftshift*sqrt(b-a)/N;
    fhathatfftshift = ifft(fftshift(fhatfftshift));
    fhathatfftshift = fhathatfftshift*N/sqrt(b-a);
    tfftshifttot(counter) = tfftshifttot(counter)+cputime-tfftshift;
  end
  errmv(counter) = norm(f-fhathatmv,Inf);
  errfft(counter) = norm(f-fhathatfft,Inf);
  errfftshift(counter) = norm(f-fhathatfftshift,Inf);
end
loglog(Nrange,tmvtot,Nrange,tffttot,Nrange,tfftshifttot)
hold on
loglog(Nrange,errmv,'*',Nrange,errfft,'+',Nrange,errfftshift,'o')
legend('CPU time MV','CPU time FFT','CPU time FFTshift','Error MV','Error FFT','Error FFTshift')
